=== modified file 'ChangeLog'
--- ChangeLog	2006-07-16 23:51:20 +0000
+++ ChangeLog	2006-07-17 14:00:33 +0000
@@ -1,5 +1,10 @@
 2006-07-17  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
+    * olive/frontend/gtk/dialog.py: some basic dialog stuff added
+    * olive/frontend/gtk/handler.py: moved dialog stuff into dialog.py
+    * olive/frontend/gtk/__init__.py: added Status column to filelist
+    * olive/backend/fileops.py: implemented status()
+    * TODO: added a TODO list
     * setup.py: some tweaks
     * olive-gtk: added main executable
     * olive/frontend/gtk/handler.py: signal handler class added (OliveHandler)

=== added file 'TODO'
--- TODO	1970-01-01 00:00:00 +0000
+++ TODO	2006-07-17 14:00:33 +0000
@@ -0,0 +1,4 @@
+TODO list for Olive
+-------------------
+
+ - Be able to install into other locations than /usr (LarstiQ)

=== modified file 'olive.glade'
--- olive.glade	2006-07-16 23:51:20 +0000
+++ olive.glade	2006-07-17 14:00:33 +0000
@@ -45,6 +45,45 @@
 		<widget class="GtkMenu" id="menuitem_file_menu">
 
 		  <child>
+		    <widget class="GtkMenuItem" id="menuitem_file_make_directory">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">Make _directory...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_file_make_directory_activate" last_modification_time="Mon, 17 Jul 2006 08:56:08 GMT"/>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkSeparatorMenuItem" id="separator_file1">
+		      <property name="visible">True</property>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkMenuItem" id="menuitem_file_rename">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Rename...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_file_rename_activate" last_modification_time="Mon, 17 Jul 2006 08:56:08 GMT"/>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkMenuItem" id="menuitem_file_move">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Move...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_file_move_activate" last_modification_time="Mon, 17 Jul 2006 08:56:08 GMT"/>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkSeparatorMenuItem" id="separator_file2">
+		      <property name="visible">True</property>
+		    </widget>
+		  </child>
+
+		  <child>
 		    <widget class="GtkImageMenuItem" id="menuitem_quit">
 		      <property name="visible">True</property>
 		      <property name="label">gtk-quit</property>
@@ -58,10 +97,108 @@
 	  </child>
 
 	  <child>
-	    <widget class="GtkMenuItem" id="menuitem_view">
+	    <widget class="GtkMenuItem" id="menuitem_branch">
 	      <property name="visible">True</property>
-	      <property name="label" translatable="yes">_View</property>
+	      <property name="label" translatable="yes">_Branch</property>
 	      <property name="use_underline">True</property>
+
+	      <child>
+		<widget class="GtkMenu" id="menuitem_branch_menu">
+
+		  <child>
+		    <widget class="GtkMenuItem" id="menuitem_branch_initialize">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Initialize</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_branch_initialize_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkMenuItem" id="menuitem_branch_branch">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Branch...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_branch_branch_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkSeparatorMenuItem" id="separator_branch1">
+		      <property name="visible">True</property>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkImageMenuItem" id="menuitem_branch_pull">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">Pu_ll</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_branch_pull_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
+
+		      <child internal-child="image">
+			<widget class="GtkImage" id="image10">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-goto-bottom</property>
+			  <property name="icon_size">1</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+		      </child>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkImageMenuItem" id="menuitem_branch_push">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">Pu_sh...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_branch_push_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
+
+		      <child internal-child="image">
+			<widget class="GtkImage" id="image11">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-goto-top</property>
+			  <property name="icon_size">1</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+		      </child>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkSeparatorMenuItem" id="separator_branch2">
+		      <property name="visible">True</property>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkImageMenuItem" id="menuitem_branch_commit">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Commit...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_branch_commit_activate" last_modification_time="Mon, 17 Jul 2006 08:53:37 GMT"/>
+
+		      <child internal-child="image">
+			<widget class="GtkImage" id="image12">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-redo</property>
+			  <property name="icon_size">1</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+		      </child>
+		    </widget>
+		  </child>
+		</widget>
+	      </child>
 	    </widget>
 	  </child>
 
@@ -111,6 +248,7 @@
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
+	      <signal name="clicked" handler="on_toolbutton_update_clicked" last_modification_time="Mon, 17 Jul 2006 09:04:16 GMT"/>
 	    </widget>
 	    <packing>
 	      <property name="expand">False</property>
@@ -119,32 +257,36 @@
 	  </child>
 
 	  <child>
-	    <widget class="GtkToolButton" id="toolbutton_log">
+	    <widget class="GtkMenuToolButton" id="menutoolbutton_log">
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Log</property>
 	      <property name="use_underline">True</property>
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
+	      <signal name="show_menu" handler="on_menutoolbutton_log_show_menu" last_modification_time="Mon, 17 Jul 2006 09:04:28 GMT"/>
+	      <signal name="clicked" handler="on_menutoolbutton_log_clicked" last_modification_time="Mon, 17 Jul 2006 09:04:37 GMT"/>
 	    </widget>
 	    <packing>
 	      <property name="expand">False</property>
-	      <property name="homogeneous">True</property>
+	      <property name="homogeneous">False</property>
 	    </packing>
 	  </child>
 
 	  <child>
-	    <widget class="GtkToolButton" id="toolbutton_diff">
+	    <widget class="GtkMenuToolButton" id="menutoolbutton_diff">
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Diff</property>
 	      <property name="use_underline">True</property>
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
+	      <signal name="show_menu" handler="on_menutoolbutton_diff_show_menu" last_modification_time="Mon, 17 Jul 2006 09:04:43 GMT"/>
+	      <signal name="clicked" handler="on_menutoolbutton_diff_clicked" last_modification_time="Mon, 17 Jul 2006 09:04:46 GMT"/>
 	    </widget>
 	    <packing>
 	      <property name="expand">False</property>
-	      <property name="homogeneous">True</property>
+	      <property name="homogeneous">False</property>
 	    </packing>
 	  </child>
 
@@ -170,6 +312,7 @@
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
+	      <signal name="clicked" handler="on_toolbutton_commit_clicked" last_modification_time="Mon, 17 Jul 2006 09:03:12 GMT"/>
 	    </widget>
 	    <packing>
 	      <property name="expand">False</property>
@@ -199,6 +342,7 @@
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
+	      <signal name="clicked" handler="on_toolbutton_pull_clicked" last_modification_time="Mon, 17 Jul 2006 09:03:19 GMT"/>
 	    </widget>
 	    <packing>
 	      <property name="expand">False</property>
@@ -215,34 +359,7 @@
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
-	    </widget>
-	    <packing>
-	      <property name="expand">False</property>
-	      <property name="homogeneous">True</property>
-	    </packing>
-	  </child>
-
-	  <child>
-	    <widget class="GtkSeparatorToolItem" id="separatortoolitem3">
-	      <property name="visible">True</property>
-	      <property name="draw">True</property>
-	      <property name="visible_horizontal">True</property>
-	      <property name="visible_vertical">True</property>
-	    </widget>
-	    <packing>
-	      <property name="expand">False</property>
-	      <property name="homogeneous">False</property>
-	    </packing>
-	  </child>
-
-	  <child>
-	    <widget class="GtkToolButton" id="toolbutton_bookmarks">
-	      <property name="visible">True</property>
-	      <property name="label" translatable="yes">Bookmarks</property>
-	      <property name="use_underline">True</property>
-	      <property name="visible_horizontal">True</property>
-	      <property name="visible_vertical">True</property>
-	      <property name="is_important">False</property>
+	      <signal name="clicked" handler="on_toolbutton_push_clicked" last_modification_time="Mon, 17 Jul 2006 09:03:24 GMT"/>
 	    </widget>
 	    <packing>
 	      <property name="expand">False</property>

=== modified file 'olive/backend/fileops.py'
--- olive/backend/fileops.py	2006-07-08 17:36:59 +0000
+++ olive/backend/fileops.py	2006-07-17 14:00:33 +0000
@@ -115,3 +115,39 @@
         raise NonExistingSource(source)
     
     move([source, target])
+
+def status(filename):
+    """ Get the status of a file.
+    
+    :param filename: the full path to the file
+    
+    :return: renamed | added | removed | modified | unchanged | unknown
+    """
+    from bzrlib.delta import compare_trees
+    from bzrlib.workingtree import WorkingTree
+    
+    try:
+        tree1 = WorkingTree.open_containing(filename)[0]
+    except errors.NotBranchError:
+        return 'unknown'
+    
+    branch = tree1.branch
+    tree2 = tree1.branch.repository.revision_tree(branch.last_revision())
+    
+    delta = compare_trees(old_tree=tree2,
+                          new_tree=tree1,
+                          want_unchanged=True,
+                          specific_files=[filename])
+    
+    if len(delta.renamed):
+        return 'renamed'
+    elif len(delta.added):
+        return 'added'
+    elif len(delta.removed):
+        return 'removed'
+    elif len(delta.modified):
+        return 'modified'
+    elif len(delta.unchanged):
+        return 'unchanged'
+    else:
+        return 'unknown'

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-07-16 23:51:20 +0000
+++ olive/frontend/gtk/__init__.py	2006-07-17 14:00:33 +0000
@@ -27,7 +27,7 @@
 except:
 	sys.exit(1)
 
-from olive.frontend.gtk.handler import OliveHandler
+from handler import OliveHandler
 
 # Olive GTK UI version
 __version__ = '0.1'
@@ -37,15 +37,24 @@
     program."""
     
     def __init__(self):
+        import os.path
+        
         # Load the glade file
         self.gladefile = "/usr/share/olive/olive.glade"
+        if not os.path.exists(self.gladefile):
+            # Load from current directory if not installed
+            self.gladefile = "olive.glade"
+
         self.toplevel = gtk.glade.XML(self.gladefile, "window_main")
         
         handler = OliveHandler(self.gladefile)
         
         # Dictionary for signal_autoconnect
         dic = { "on_window_main_destroy": gtk.main_quit,
-                "on_about_activate": handler.about }
+                "on_quit_activate": gtk.main_quit,
+                "on_about_activate": handler.on_about_activate,
+                "on_menuitem_file_make_directory_activate": handler.not_implemented,
+                "on_menuitem_branch_commit_activate": handler.not_implemented }
         
         # Connect the signals to the handlers
         self.toplevel.signal_autoconnect(dic)
@@ -53,20 +62,22 @@
         # Load default data into the panels
         self.treeview_left = self.toplevel.get_widget('treeview_left')
         self.treeview_right = self.toplevel.get_widget('treeview_right')
-        self.load_left()
-        self.load_right()
+        self._load_left()
+        self._load_right()
     
-    def load_left(self):
+    def _load_left(self):
         """ Load data into the left panel. (Bookmarks) """
         pass
         
-    def load_right(self):
+    def _load_right(self):
         """ Load data into the right panel. (Filelist) """
         import os
         import os.path
         
+        import olive.backend.fileops as fileops
+        
         # Create ListStore
-        liststore = gtk.ListStore(str, str)
+        liststore = gtk.ListStore(str, str, str)
         
         dirs = []
         files = []
@@ -84,16 +95,18 @@
         
         # Add'em to the ListStore
         for item in dirs:    
-            liststore.append(['D', item])
+            liststore.append(['D', item, ''])
         for item in files:
-            liststore.append(['', item])
+            liststore.append(['', item, fileops.status(item)])
         
         # Create the columns and add them to the TreeView
         self.treeview_right.set_model(liststore)
+        tvcolumn_filetype = gtk.TreeViewColumn('Type')
         tvcolumn_filename = gtk.TreeViewColumn('Filename')
-        tvcolumn_filetype = gtk.TreeViewColumn('Type')
+        tvcolumn_status = gtk.TreeViewColumn('Status')
         self.treeview_right.append_column(tvcolumn_filetype)
         self.treeview_right.append_column(tvcolumn_filename)
+        self.treeview_right.append_column(tvcolumn_status)
         
         # Set up the cells
         cell = gtk.CellRendererText()
@@ -101,3 +114,5 @@
         tvcolumn_filetype.add_attribute(cell, 'text', 0)
         tvcolumn_filename.pack_start(cell, True)
         tvcolumn_filename.add_attribute(cell, 'text', 1)
+        tvcolumn_status.pack_start(cell, True)
+        tvcolumn_status.add_attribute(cell, 'text', 2)

=== added file 'olive/frontend/gtk/dialog.py'
--- olive/frontend/gtk/dialog.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/dialog.py	2006-07-17 14:00:33 +0000
@@ -0,0 +1,77 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import sys
+
+try:
+ 	import pygtk
+  	pygtk.require("2.0")
+except:
+  	pass
+try:
+	import gtk
+  	import gtk.glade
+except:
+	sys.exit(1)
+
+class OliveDialog:
+    def __init__(self, gladefile):
+        self.gladefile = gladefile
+        
+    def about(self):
+        """ Display the AboutDialog. """
+        import olive.frontend.gtk
+
+        # Load AboutDialog description
+        dglade = gtk.glade.XML(self.gladefile, 'aboutdialog')
+        dialog = dglade.get_widget('aboutdialog')
+
+        # Set version
+        dialog.set_version(olive.frontend.gtk.__version__)
+    
+    def _message_dialog(self, type, message):
+        """ Display a given type of MessageDialog with the given message.
+        
+        :param type: error | warning | info
+        
+        :param message: the message you want to display.
+        """
+        if type == 'error':
+            dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
+                                       type=gtk.MESSAGE_ERROR,
+                                       buttons=gtk.BUTTONS_OK)
+            dialog.set_markup('<big><b>Error!</b></big>')
+        elif type == 'warning':
+            dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
+                                       type=gtk.MESSAGE_WARNING,
+                                       buttons=gtk.BUTTONS_OK)
+            dialog.set_markup('<big><b>Warning!</b></big>')
+        elif type == 'info':
+            dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
+                                       type=gtk.MESSAGE_INFO,
+                                       buttons=gtk.BUTTONS_OK)
+            dialog.set_markup('<big><b>Information</b></big>')
+        else:
+            return
+        
+        dialog.format_secondary_text(message)
+        
+        if dialog.run() == gtk.RESPONSE_OK:
+            dialog.destroy()
+    
+    def error_dialog(self, message):
+        """ Display an error dialog with the given message. """
+        self._message_dialog('error', message)

=== modified file 'olive/frontend/gtk/handler.py'
--- olive/frontend/gtk/handler.py	2006-07-16 23:51:20 +0000
+++ olive/frontend/gtk/handler.py	2006-07-17 14:00:33 +0000
@@ -27,17 +27,18 @@
 except:
 	sys.exit(1)
 
+from dialog import OliveDialog
+
 class OliveHandler:
     """ Signal handler class for Olive. """
     def __init__(self, gladefile):
         self.gladefile = gladefile
-    
-    def about(self, widget):
-        import olive.frontend.gtk
-
-        # Load AboutDialog description
-        dglade = gtk.glade.XML(self.gladefile, 'aboutdialog')
-        dialog = dglade.get_widget('aboutdialog')
-
-        # Set version
-        dialog.set_version(olive.frontend.gtk.__version__)
+        self.dialog = OliveDialog(self.gladefile)
+    
+    def on_about_activate(self, widget):
+        self.dialog.about()
+    
+    def not_implemented(self, widget):
+        """ Display a Not implemented error message. """
+        self.dialog.error_dialog('This feature is not yet implemented.')
+

